#!/usr/bin/env python
# -*- coding: utf-8 -*-


# ******************** MrQ Halloween animated scene.py *******************************************************************************************************************

# Initial Relase: Ver.0.1 MareroQ 25/09/22 %03d will change the number to have 3 digits, e.g. 001, 002, 003 - 3 here is padding length.
# 				  Ver.0.2 MareroQ 01/10/22 added new type animation: "Sliding","Ripple & Sliding", "Crease"
# 				  Ver.0.3 MareroQ 02/10/22 added new type animation:"Shrink","Rotate", added new options "Reverse Frames" and efect Ping-Pong
# 				  Ver.0.4 MareroQ 04/10/22 added new type animation: "Deform","Edges on Fire","Typewriter" (using code by Tin Tran character-layers-from-text.py)

# ******************** MrQ Animated Scene.py ******************************************************************************************************************************

# 				  Ver.1.0 MareroQ 06/10/22: - new plugin interface based on gimpfu3 by J.F.Garcia [arakne],
#                                           - more options for creating backgrounds,
#                                           - bumpmap and neon-glow as user selectable option. 
# 				  Ver.1.1 MareroQ 09/10/22: - added option to choose scaling for background loaded from file:"Scale Loaded Layer to Frames","Scale Frames to Loaded Layer"
# 											- added option "Scale Animation (%)"
# 											- added new type animation: "From Top to Bottom", "Explode"
# 											- added option to Back and Front Text "Apply an additional decorative effect:["Camouflage","Canvas","Crystal","Cubism","Denim","Edge","Edge Neon","Edge Sobel","Engrave","Gradient Map","Mosaic","Pixelize","Plasma","Rainbow","Video Degradation"]" 
# 				  Ver.1.2 MareroQ 11/10/22: - small reorganization of gui,
#                                           - in addition to the color, the text may be filled with a pattern,
# 											- added new type animation: "Raindrops","Scanlines", "Wave","Water",
#                                           - added new type Apply Effect(decorative): "Dirty", "Ministeck","Super-Pixels Colors Average", "Super-Pixels Colors Random".
# 				  Ver.1.3 MareroQ 12/10/22: - added option to Front: "Create Front From": "Text" or "Load Selected Layer (with transparency)",
# 											- added new type animation: "Rotation about Y axis", "Rotation about X axis"
# 				  Ver.1.4 MareroQ 18/10/22: - added option to Back: "Create Back From": "Text" or "Load Selected Layer (with transparency)" or "Don't Use",
#											- for tab "Background" replace "Load selected file" to "Load selected Layer" (opened in Gimp - more control to size)
# 											- added new tab 'Overlay' (to apply a frame, signature or avatar)
# 				  Ver.1.5 MareroQ 22/10/22: - for tab 'Back' added option Align: TOP,BOTTOM,
#                                           - for tab 'Overlay' added option Align: MIDDLE,TOP,BOTTOM,RIGHT,LEFT
#                                           - added new type animation: Lava
#                                           - added new type Apply Effect(decorative):Grid Cartesian,Grid Triangular
# 				  Ver.1.6 MareroQ 24/10/22: - for tab "Background ➤Resize Selected added option:Not Resize when you want to create an animation the size of the loaded layer
#						                      (but the dimensions Back and Front must be smaller than the loaded layer!).
# 											- added new type animation: "From Top-Left to Bottom-Right","From Top-Right to Bottom-Left"
# **************************************************************************************************************************************************************************
# Inspired by Pocholo plugins located here: pm_create_a_halloween_scene.py http://gimpchat.com/viewtopic.php?f=9&t=19656
#                                           pm_halloween_graveyard_scene.py http://gimpchat.com/viewtopic.php?f=9&t=20126
# 											pm_animated_dancing_ghost.py http://gimpchat.com/viewtopic.php?f=9&t=20106
# **************************************************************************************************************************************************************************

# Installation:
# This plug should be placed in the user plugins folder
# Scroll bar for Python plugins https://www.gimpscripts.net/2020/10/python-fu-dialogs-window-shrink.html

# Copyright (C)

#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by   
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY# without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <https://www.gnu.org/licenses/>.   

############################################################################################################################################################
########################################################## START gimpfu3 by J.F.Garcia [arakne] ############################################################
############################################################################################################################################################
#   Gimp-Python - allows the writing of GIMP plug-ins in Python.
#   Copyright (C) 1997  James Henstridge <james@daa.com.au>
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.

from gimpshelf import shelf
import string as _string
import math
import gimp
import gimpcolor
import re
from gimpenums import *
pdb = gimp.pdb

import gettext
t = gettext.translation("gimp20-python", gimp.locale_directory, fallback=True)
_ = t.ugettext

class error(RuntimeError): pass
class CancelError(RuntimeError): pass

PF_INT8        = PDB_INT8
PF_INT16       = PDB_INT16
PF_INT32       = PDB_INT32
PF_INT         = PF_INT32
PF_FLOAT       = PDB_FLOAT
PF_STRING      = PDB_STRING
PF_VALUE       = PF_STRING
PF_COLOR       = PDB_COLOR
PF_COLOUR      = PF_COLOR
PF_ITEM        = PDB_ITEM
PF_DISPLAY     = PDB_DISPLAY
PF_IMAGE       = PDB_IMAGE
PF_LAYER       = PDB_LAYER
PF_CHANNEL     = PDB_CHANNEL
PF_DRAWABLE    = PDB_DRAWABLE
PF_VECTORS     = PDB_VECTORS

PF_TOGGLE      = 1000
PF_BOOL        = PF_TOGGLE
PF_SLIDER      = 1001
PF_SPINNER     = 1002
PF_ADJUSTMENT  = PF_SPINNER

PF_FONT        = 1003
PF_FILE        = 1004
PF_BRUSH       = 1005
PF_PATTERN     = 1006
PF_GRADIENT    = 1007
PF_RADIO       = 1008
PF_TEXT        = 1009
PF_PALETTE     = 1010
PF_FILENAME    = 1011
PF_DIRNAME     = 1012
PF_OPTION      = 1013
PF_TAB         = 1014
PF_DRAW        = 1015
PF_TITLE       = 1016

_type_mapping = {
    PF_INT8        : PDB_INT8,
    PF_INT16       : PDB_INT16,
    PF_INT32       : PDB_INT32,
    PF_FLOAT       : PDB_FLOAT,
    PF_STRING      : PDB_STRING,
    PF_COLOR       : PDB_COLOR,
    PF_ITEM        : PDB_ITEM,
    PF_DISPLAY     : PDB_DISPLAY,
    PF_IMAGE       : PDB_IMAGE,
    PF_LAYER       : PDB_LAYER,
    PF_CHANNEL     : PDB_CHANNEL,
    PF_DRAWABLE    : PDB_DRAWABLE,
    PF_VECTORS     : PDB_VECTORS,

    PF_TOGGLE      : PDB_INT32,
    PF_SLIDER      : PDB_FLOAT,
    PF_SPINNER     : PDB_INT32,

    PF_FONT        : PDB_STRING,
    PF_FILE        : PDB_STRING,
    PF_BRUSH       : PDB_STRING,
    PF_PATTERN     : PDB_STRING,
    PF_GRADIENT    : PDB_STRING,
    PF_RADIO       : PDB_STRING,
    PF_TEXT        : PDB_STRING,
    PF_PALETTE     : PDB_STRING,
    PF_FILENAME    : PDB_STRING,
    PF_DIRNAME     : PDB_STRING,
    PF_OPTION      : PDB_INT32,
    PF_TAB         : PDB_STRING,
    PF_DRAW        : PDB_INT32,
    PF_TITLE       : PDB_STRING,
}

_obj_mapping = {
    PF_INT8        : int,
    PF_INT16       : int,
    PF_INT32       : int,
    PF_FLOAT       : float,
    PF_STRING      : str,
    PF_COLOR       : gimpcolor.RGB,
    PF_ITEM        : int,
    PF_DISPLAY     : gimp.Display,
    PF_IMAGE       : gimp.Image,
    PF_LAYER       : gimp.Layer,
    PF_CHANNEL     : gimp.Channel,
    PF_DRAWABLE    : gimp.Drawable,
    PF_VECTORS     : gimp.Vectors,

    PF_TOGGLE      : bool,
    PF_SLIDER      : float,
    PF_SPINNER     : int,

    PF_FONT        : str,
    PF_FILE        : str,
    PF_BRUSH       : str,
    PF_PATTERN     : str,
    PF_GRADIENT    : str,
    PF_RADIO       : str,
    PF_TEXT        : str,
    PF_PALETTE     : str,
    PF_FILENAME    : str,
    PF_DIRNAME     : str,
    PF_OPTION      : int,
    PF_TAB         : str,
    PF_DRAW        : int,
    PF_TITLE       : str,
}

_registered_plugins_ = {}

def register(proc_name, blurb, help, author, copyright, date, label, imagetypes, params, results, function, menu=None, domain=None, on_query=None, on_run=None):
    """This is called to register a new plug-in."""

    # First perform some sanity checks on the data
    def letterCheck(str):
        allowed = _string.letters + _string.digits + "_" + "-"
        for ch in str:
            if not ch in allowed:
		return 0
        else:
            return 1

    if not letterCheck(proc_name):
        raise error, "procedure name contains illegal characters"

    for ent in params:
        if len(ent) < 4:
            raise error, ("parameter definition must contain at least 4 "
                          "elements (%s given: %s)" % (len(ent), ent))

        if type(ent[0]) != int:
            raise error, "parameter types must be integers"

        if not letterCheck(ent[1]):
            raise error, "parameter name contains illegal characters"

    for ent in results:
        if len(ent) < 3:
            raise error, ("result definition must contain at least 3 elements (%s given: %s)" % (len(ent), ent))

        if type(ent[0]) != type(42):
            raise error, "result types must be integers"

        if not letterCheck(ent[1]):
            raise error, "result name contains illegal characters"

    plugin_type = PLUGIN

    if (not proc_name.startswith("python-") and
        not proc_name.startswith("python_") and
        not proc_name.startswith("extension-") and
        not proc_name.startswith("extension_") and
        not proc_name.startswith("plug-in-") and
        not proc_name.startswith("plug_in_") and
        not proc_name.startswith("file-") and
        not proc_name.startswith("file_")):
           proc_name = "python-fu-" + proc_name

    # if menu is not given, derive it from label
    need_compat_params = False
    if menu is None and label:
        fields = label.split("/")
        if fields:
            label = fields.pop()
            menu = "/".join(fields)
            need_compat_params = True

            import warnings
            message = ("%s: passing the full menu path for the menu label is "
                       "deprecated, use the 'menu' parameter instead" % (proc_name))
            warnings.warn(message, DeprecationWarning, 3)

        if need_compat_params and plugin_type == PLUGIN:
            file_params = [(PDB_STRING, "filename", "The name of the file", ""),
                           (PDB_STRING, "raw-filename", "The name of the file", "")]

            if menu is None:
                pass
            elif menu.startswith("<Load>"):
                params[0:0] = file_params
            elif menu.startswith("<Image>") or menu.startswith("<Save>"):
                params.insert(0, (PDB_IMAGE, "image", "Input image", None))
                params.insert(1, (PDB_DRAWABLE, "drawable", "Input drawable", None))
                if menu.startswith("<Save>"):
                    params[2:2] = file_params

    _registered_plugins_[proc_name] = (blurb, help, author, copyright, date, label, imagetypes, plugin_type, params, results, function, menu, domain, on_query, on_run)

def _query():
    for plugin in _registered_plugins_.keys():
        (blurb, help, author, copyright, date, label, imagetypes, plugin_type, params, results, function, menu, domain, on_query, on_run) = _registered_plugins_[plugin]

        def make_params(params):
            return [(_type_mapping[x[0]], x[1], _string.replace(x[2], "_", "")) for x in params]

        params = make_params(params)
        # add the run mode argument ...
        params.insert(0, (PDB_INT32, "run-mode", "The run mode { RUN-INTERACTIVE (0), RUN-NONINTERACTIVE (1) }"))

        results = make_params(results)

        if domain:
            try:
                (domain, locale_dir) = domain
                gimp.domain_register(domain, locale_dir)
            except ValueError:
                gimp.domain_register(domain)

        gimp.install_procedure(plugin, blurb, help, author, copyright, date, label, imagetypes, plugin_type, params, results)
        if menu:
            gimp.menu_register(plugin, menu)
        if on_query:
            on_query()

def getXtra(xtra, valName, defValue):
    p = defValue
    if xtra.get(valName):
        p = xtra.get(valName)
    return p

def _get_defaults(proc_name):
    import gimpshelf

    (blurb, help, author, copyright, date, label, imagetypes, plugin_type, params, results, function, menu, domain, on_query, on_run) = _registered_plugins_[proc_name]

    key = "python-fu-save--" + proc_name

    if gimpshelf.shelf.has_key(key):
        return gimpshelf.shelf[key]
    else:
        # return the default values
        return [x[3] for x in params]

def _set_defaults(proc_name, defaults):
    import gimpshelf

    key = "python-fu-save--" + proc_name
    gimpshelf.shelf[key] = defaults

def _interact(proc_name, start_params):
    (blurb, help, author, copyright, date, label, imagetypes, plugin_type, params, results, function, menu, domain, on_query, on_run) = _registered_plugins_[proc_name]

    def run_script(run_params):
        params = start_params + tuple(run_params)
        _set_defaults(proc_name, params)
        return apply(function, params)

    params = params[len(start_params):]

    # short circuit for no parameters ...
    if len(params) == 0:
         return run_script([])

    import pygtk
    pygtk.require('2.0')

    import gimpui, gtk
    gimpui.gimp_ui_init ()  # add MrQ	
#    import pango

    defaults = _get_defaults(proc_name)
    defaults = defaults[len(start_params):]

    class EntryValueError(Exception):
        pass

    def warning_dialog(parent, primary, secondary=None):
        dlg = gtk.MessageDialog(parent, gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_WARNING, gtk.BUTTONS_CLOSE, primary)
        if secondary:
            dlg.format_secondary_text(secondary)
        dlg.run()
        dlg.destroy()

    def error_dialog(parent, proc_name):
        import sys, traceback

        exc_str = exc_only_str = _("Missing exception information")
        try:
            etype, value, tb = sys.exc_info()
            exc_str = "".join(traceback.format_exception(etype, value, tb))
            exc_only_str = "".join(traceback.format_exception_only(etype, value))
        finally:
            etype = value = tb = None

        title = _("An error occurred running %s") % proc_name
        dlg = gtk.MessageDialog(parent, gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_ERROR, gtk.BUTTONS_CLOSE, title)
        dlg.format_secondary_text(exc_only_str)

        alignment = gtk.Alignment(0.0, 0.0, 1.0, 1.0)
        alignment.set_padding(0, 0, 12, 12)
        dlg.vbox.pack_start(alignment)
        alignment.show()

        expander = gtk.Expander(_("_More Information"));
        expander.set_use_underline(True)
        expander.set_spacing(6)
        alignment.add(expander)
        expander.show()

        scrolled = gtk.ScrolledWindow()
        scrolled.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        scrolled.set_size_request(-1, 200)
        expander.add(scrolled)
        scrolled.show()

        label = gtk.Label(exc_str)
        label.set_alignment(0.0, 0.0)
        label.set_padding(6, 6)
        label.set_selectable(True)
        scrolled.add_with_viewport(label)
        label.show()

        def response(widget, id):
            widget.destroy()

        dlg.connect("response", response)
        dlg.set_resizable(True)
        dlg.show()

    # define a mapping of param types to edit objects ...
    class StringEntry(gtk.Entry):
        def __init__(self, default=""):
            gtk.Entry.__init__(self)
            self.set_text(str(default))
            #self.set_line_wrap(True)
            #self.set_single_line_mode(False)

        def get_value(self):
            return self.get_text()

    class LabelTitle(gtk.Label):
        def __init__(self, default="", align = (0.0, 0.0)):
            gtk.Label.__init__(self)
            self.set_label(str(default))
            self.set_use_markup(True)
            if align != None:
                self.set_alignment(align[0],align[1])
        def get_value(self):
            return self.get_label()

    class TextEntry(gtk.ScrolledWindow):
        def __init__ (self, default=""):
            gtk.ScrolledWindow.__init__(self)
            self.set_shadow_type(gtk.SHADOW_IN)

            self.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
            self.set_size_request(100, -1)

            self.view = gtk.TextView()
            self.add(self.view)
            self.view.show()
            self.buffer = self.view.get_buffer()
            self.set_value(str(default))

        def set_value(self, text):
            self.buffer.set_text(text)

        def get_value(self):
            return self.buffer.get_text(self.buffer.get_start_iter(), self.buffer.get_end_iter())

    class IntEntry(StringEntry):
        def get_value(self):
            try:
                return int(self.get_text())
            except ValueError, e:
                raise EntryValueError, e.args

    class FloatEntry(StringEntry):
            def get_value(self):
                try:
                    return float(self.get_text())
                except ValueError, e:
                    raise EntryValueError, e.args

    def precision(step):
        # calculate a reasonable precision from a given step size
        if math.fabs(step) >= 1.0 or step == 0.0:
            digits = 0
        else:
            digits = abs(math.floor(math.log10(math.fabs(step))));
        if digits > 20:
            digits = 20
        return int(digits)

    class SliderEntry(gtk.HScale):
        # bounds is (upper, lower, step)
        def __init__(self, default=0, bounds=(0, 100, 5)):
            step = bounds[2]
            self.adj = gtk.Adjustment(default, bounds[0], bounds[1], step, 10 * step, 0)
            gtk.HScale.__init__(self, self.adj)
            self.set_digits(precision(step))

        def get_value(self):
            return self.adj.value

    class SpinnerEntry(gtk.SpinButton):
        # bounds is (upper, lower, step)
        def __init__(self, default=0, bounds=(0, 100, 5)):
            step = bounds[2]
            self.adj = gtk.Adjustment(default, bounds[0], bounds[1], step, 10 * step, 0)
            gtk.SpinButton.__init__(self, self.adj, step, precision(step))

    class ToggleEntry(gtk.ToggleButton):
        def __init__(self, default=0, labels=[_("No"),_("Yes")]):
            gtk.ToggleButton.__init__(self)
            self.labels = labels
            self.label = gtk.Label(labels[0])
            self.add(self.label)
            self.label.show()
            self.connect("toggled", self.changed)
            self.set_active(default)

        def changed(self, tog):
            if tog.get_active():
                self.label.set_text(self.labels[1])
            else:
                self.label.set_text(self.labels[0])

        def get_value(self):
            return self.get_active()

    class RadioEntry(gtk.VBox):
        def __init__(self, default=0, items=((_("Yes"), 1), (_("No"), 0))):
            gtk.VBox.__init__(self, homogeneous=False, spacing=2)

            button = None

            for (label, value) in items:
                button = gtk.RadioButton(button, label)
                self.pack_start(button)
                button.show()

                button.connect("toggled", self.changed, value)

                if value == default:
                    button.set_active(True)
                    self.active_value = value

        def changed(self, radio, value):
            if radio.get_active():
                self.active_value = value

        def get_value(self):
            return self.active_value

    class ComboEntry(gtk.ComboBox):
        def __init__(self, default=0, items=()):
            store = gtk.ListStore(str)
            for item in items:
                store.append([item])

            gtk.ComboBox.__init__(self, model=store)

            cell = gtk.CellRendererText()
            self.pack_start(cell)
            self.set_attributes(cell, text=0)

            self.set_active(default)

        def get_value(self):
            return self.get_active()

    def FileSelector(default=""):
        # FIXME: should this be os.path.separator?  If not, perhaps explain why?
        if default and default.endswith("/"):
            selector = DirnameSelector
            if default == "/": default = ""
        else:
            selector = FilenameSelector
        return selector(default)

    class FilenameSelector(gtk.FileChooserButton):
        def __init__(self, default="", save_mode=False):
            gtk.FileChooserButton.__init__(self,_("Python-Fu File Selection"))
            self.set_action(gtk.FILE_CHOOSER_ACTION_OPEN)
            if default:
                self.set_filename(default)

        def get_value(self):
            return self.get_filename()

    class DirnameSelector(gtk.FileChooserButton):
        def __init__(self, default=""):
            gtk.FileChooserButton.__init__(self,_("Python-Fu Folder Selection"))
            self.set_action(gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER)
            if default:
                self.set_filename(default)

        def get_value(self):
            return self.get_filename()

    class DrawCanvas(gtk.DrawingArea):
        def __init__(self,default, size=(100,100)):
            gtk.DrawingArea.__init__(self)
            self.set_size_request(size[0],size[1])
        def get_value(self):
            return 0

    _edit_mapping = {
            PF_INT8        : IntEntry,
            PF_INT16       : IntEntry,
            PF_INT32       : IntEntry,
            PF_FLOAT       : FloatEntry,
            PF_STRING      : StringEntry,
            PF_COLOR       : gimpui.ColorSelector,
            PF_ITEM        : IntEntry,  # should handle differently ...
            PF_IMAGE       : gimpui.ImageSelector,
            PF_LAYER       : gimpui.LayerSelector,
            PF_CHANNEL     : gimpui.ChannelSelector,
            PF_DRAWABLE    : gimpui.DrawableSelector,
            PF_VECTORS     : gimpui.VectorsSelector,

            PF_TOGGLE      : ToggleEntry,
            PF_SLIDER      : SliderEntry,
            PF_SPINNER     : SpinnerEntry,
            PF_RADIO       : RadioEntry,
            PF_OPTION      : ComboEntry,

            PF_FONT        : gimpui.FontSelector,
            PF_FILE        : FileSelector,
            PF_FILENAME    : FilenameSelector,
            PF_DIRNAME     : DirnameSelector,
            PF_BRUSH       : gimpui.BrushSelector,
            PF_PATTERN     : gimpui.PatternSelector,
            PF_GRADIENT    : gimpui.GradientSelector,
            PF_PALETTE     : gimpui.PaletteSelector,
            PF_TEXT        : TextEntry,
            PF_TAB         : TextEntry,
            PF_DRAW        : DrawCanvas,
            PF_TITLE       : LabelTitle,
    }
    # JFGARCIA - modified: to pass args to the on_run
    if on_run:
        on_run(start_params+tuple(params))

    dialog = gimpui.Dialog(proc_name, "python-fu", None, 0, None, proc_name, (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL, gtk.STOCK_OK, gtk.RESPONSE_OK))

    dialog.set_alternative_button_order((gtk.RESPONSE_OK, gtk.RESPONSE_CANCEL))

    dialog.set_transient()

    vbox = gtk.VBox(False, 12)
    vbox.set_border_width(12)
    dialog.vbox.pack_start(vbox)
    vbox.show()

    if blurb:
        if domain:
            try:
                (domain, locale_dir) = domain
                trans = gettext.translation(domain, locale_dir, fallback=True)
            except ValueError:
                trans = gettext.translation(domain, fallback=True)
            blurb = trans.ugettext(blurb)
        box = gimpui.HintBox(blurb)
        vbox.pack_start(box, expand=False)
        box.show()

    table = gtk.Table(1, 2, False)
    table.set_row_spacings(2)
    table.set_col_spacings(2)
    vbox.pack_start(table, expand=True)
    table.show()

    notebook = gtk.Notebook()
    tables=[]
    for i in range(len(params)):
        if params[i][0]==PF_TAB:
            vals = params[i][4]
            currPage = params[i][3]

            for n in vals:
                tbl = gtk.Table(2, 2, False)
                tbl.set_row_spacings(5)
                tbl.set_col_spacings(5)
                tbl.show()
                tables.append({'table':tbl,'rows':0, 'totCols':0})
                notebook.append_page(tbl, gtk.Label(n))
                notebook.set_current_page(currPage)


    if len(tables)>0:
        table.attach(notebook, 0,6,0,1)
        notebook.show()
    else:
        tables.append({'table':table,'rows':0})

    def response(dlg, id):
        if id == gtk.RESPONSE_OK:
            dlg.set_response_sensitive(gtk.RESPONSE_OK, False)
            dlg.set_response_sensitive(gtk.RESPONSE_CANCEL, False)
            params = []
            try:
                for wid in edit_wids:
                    params.append(wid.get_value())
            except EntryValueError:
                warning_dialog(dialog, _("Invalid input for '%s'") % wid.desc)
            else:
                try:
                    dialog.res = run_script(params)
                except Exception:
                    dlg.set_response_sensitive(gtk.RESPONSE_CANCEL, True)
                    error_dialog(dialog, proc_name)
                    raise
        gtk.main_quit()

    iniX=0
    dialog.connect("response", response)
    row=0
    edit_wids = []

    for i in range(len(params)):
        paramsi = params[i]
        pf_type = paramsi[0]
        name, desc = (paramsi[1], paramsi[2])
        def_val = defaults[i]
 
        tab, incr, rows, connect, cols, hlp = (0, 1, 1, None, 1, desc)
        if len(params[i])>5:
            xtra = params[i][5]
            incr = int(getXtra(xtra, 'newLine', 1))
            if incr==0 : cols = 1
            cols = getXtra(xtra, 'cols'   , cols)
            iniX = getXtra(xtra, 'iniCol' , iniX)
            rows = getXtra(xtra, 'rows'   , 1)
            tab  = getXtra(xtra, 'tab'    , 0)
            hlp  = getXtra(xtra, 'help'   , desc)
            connect = getXtra(xtra,'connect', None)
        else:
            iniX = 0
        tbl = tables[tab]['table']
        row = tables[tab]['rows']


        if pf_type==PF_TAB:
            wid = _edit_mapping[pf_type](None)
        else:
            if pf_type != PF_TITLE and desc != '':
                label = gtk.Label(desc)
                label.set_use_underline(True)
                label.set_alignment(0.0, 0.5)
                tbl.attach(label, iniX + 1, iniX + 2, row, row + rows, xoptions = gtk.FILL)
                label.show()

            if pf_type in (PF_SPINNER, PF_SLIDER, PF_RADIO, PF_OPTION, PF_DRAW ):
                wid = _edit_mapping[pf_type](def_val, paramsi[4])
            elif pf_type==PF_TOGGLE:
                if isinstance(paramsi[4], list):
                    wid = _edit_mapping[pf_type](def_val, paramsi[4])
                else:
                    wid = _edit_mapping[pf_type](def_val)
            elif pf_type==PF_TITLE:
                wid = _edit_mapping[pf_type](desc)
            else:
                wid = _edit_mapping[pf_type](def_val)
            if pf_type!=PF_TITLE and desc != '':
                label.set_mnemonic_widget(wid)
                tbl.attach(wid, iniX + 2, iniX + 2 + cols, row, row + rows, yoptions=0)
                iniX = iniX + cols + 1
            else:
                tbl.attach(wid, iniX, iniX+cols, row, row + rows, xoptions=gtk.FILL)
            # jfGarcia: strip html tags from toolTip
            tTip = re.sub('<[^<]+?>', '', hlp)
            if pf_type != PF_TEXT:
                wid.set_tooltip_text(tTip)
            else:
                # Attach tip to TextView, not to ScrolledWindow
                wid.view.set_tooltip_text(tTip)

            wid.set_name(name)
            if connect:
                try:
                    wid.connect(connect['signal'],connect['function'])
                except Exception, e:
                    pass
            wid.show()
            wid.desc = desc

        edit_wids.append(wid)

        tables[tab]['rows'] += incr
        if incr==1:
           iniX=0

    progress_vbox = gtk.VBox(False, 6)
    vbox.pack_end(progress_vbox, expand=False)
    progress_vbox.show()

    progress = gimpui.ProgressBar()
    progress_vbox.pack_start(progress)
    progress.show()

    dialog.show()

    gtk.main()

    if hasattr(dialog, "res"):
        res = dialog.res
        dialog.destroy()
        return res
    else:
        dialog.destroy()
        raise CancelError

def _run(proc_name, params):
    run_mode = params[0]
    func = _registered_plugins_[proc_name][10]

    if run_mode == RUN_NONINTERACTIVE:
        return apply(func, params[1:])

    script_params = _registered_plugins_[proc_name][8]

    min_args = 0
    if len(params) > 1:
        for i in range(1, len(params)):
            param_type = _obj_mapping[script_params[i - 1][0]]
            if not isinstance(params[i], param_type):
                break
        min_args = i
    if len(script_params) > min_args:
        start_params = params[:min_args + 1]
        if run_mode == RUN_WITH_LAST_VALS:
            default_params = _get_defaults(proc_name)
            params = start_params + default_params[min_args:]
        else:
            params = start_params
    else:
       run_mode = RUN_NONINTERACTIVE
    if run_mode == RUN_INTERACTIVE:
        try:
            res = _interact(proc_name, params[1:])
        except CancelError:
            return
    else:
        res = apply(func, params[1:])
        gimp.displays_flush()
    return res

def main():
    """This should be called after registering the plug-in."""
    gimp.main(None, None, _query, _run)

def fail(msg):
    """Display an error message and quit"""
    gimp.message(msg)
    raise error, msg

def N_(message):
    return message


############################################################################################################################################################
######################################################### END gimpfu3 ######################################################################################
############################################################################################################################################################

####################################################################################################################
################# START gegl_command by Kevin Payne & Claude Lion ##################################################
####################################################################################################################

from sys import platform
from ctypes import *

def load_library (library_name):
	if platform == "linux" or platform == "linux2":
		library_name = library_name + '.so.0'
	elif platform == "win32":
		from ctypes.util import find_library
		library_name = find_library (library_name + "-0")
	else:
		raise BaseException ("TODO")
	return CDLL (library_name)

gimpC = load_library ('libgimp-2.0')


def gegl_anim(image, drawable, gegl_graph_string):
	
	class GeglBuffer(Structure):
		pass
	drawable_id = drawable.ID
	
	gegl = load_library ('libgegl-0.4')
	gegl.gegl_init (None, None)
	gimpC.gimp_drawable_get_shadow_buffer.restype = POINTER (GeglBuffer)
	gimpC.gimp_drawable_get_buffer.restype        = POINTER (GeglBuffer)

	x = c_int (); y = c_int (); w = c_int (); h = c_int ()
	non_empty,x,y,w,h = pdb.gimp_drawable_mask_intersect (drawable)
	args = [b"string", c_char_p (gegl_graph_string), c_void_p ()]
	
	if non_empty:
		source = gimpC.gimp_drawable_get_buffer (drawable_id)
		target = gimpC.gimp_drawable_get_shadow_buffer (drawable_id)
		gegl.gegl_render_op (source, target, "gegl:gegl", *args)
		gegl.gegl_buffer_flush (target)
		gimpC.gimp_drawable_merge_shadow (drawable_id, PushUndo = True)
		gimpC.gimp_drawable_update (drawable_id, x, y, w, h)
		gimpC.gimp_displays_flush ()
		
####################################################################################################################
################# END gegl_command #################################################################################
####################################################################################################################
import os, sys
import math
import string
from array import array
import random

################################################# STATR ##########################################################
# character-layers-from-text.py created by Tin Tran https://gimplearn.net/viewtopic.php?f=3&t=2606 Rel 1.
def python_character_layers_from_text(image, textlayer):

	pdb.gimp_image_undo_group_start(image)
	#pdb.gimp_context_push()
	text = pdb.gimp_text_layer_get_text(textlayer)
	font = pdb.gimp_text_layer_get_font(textlayer)
	font_size,unit = pdb.gimp_text_layer_get_font_size(textlayer)
	offset_x,offset_y = pdb.gimp_drawable_offsets(textlayer)
	lines = text.split("\n")
	starting_y = offset_y
	for line in lines:
		textlayers = []
		totalwidth = 0
		for i in range(0,len(line)):
			char = line[i]
			if ((char == " ") and (i > 0) and (i < len(line)-1)): #if space and it's between 2 chararacters we treat it special
				before = line[i-1]
				space = line[i]
				after = line[i+1]
				special = before + space + after
				special_layer = pdb.gimp_text_fontname(image,None,0,0,special,0,TRUE,font_size,unit,font)
				before_layer = pdb.gimp_text_fontname(image,None,0,0,before,0,TRUE,font_size,unit,font)
				after_layer = pdb.gimp_text_fontname(image,None,0,0,after,0,TRUE,font_size,unit,font)
				layer_height = special_layer.height
				layer_width = special_layer.width - before_layer.width - after_layer.width
				text_layer = pdb.gimp_layer_new(image,layer_width,layer_height,RGBA_IMAGE,"Space",100,LAYER_MODE_NORMAL)
				pdb.gimp_image_insert_layer(image,text_layer,None,0)
				pdb.gimp_image_remove_layer(image,before_layer)
				pdb.gimp_image_remove_layer(image,after_layer)
				pdb.gimp_image_remove_layer(image,special_layer)
			else:
				text_layer = pdb.gimp_text_fontname(image,None,0,0,char,0,TRUE,font_size,unit,font)
			totalwidth += text_layer.width 
			textlayers.append(text_layer)

		starting_x = offset_x + (textlayer.width/2) - totalwidth/2
		for text_layer in textlayers: #loop through and move it into its placement
			pdb.gimp_layer_set_offsets(text_layer,starting_x,starting_y)
			starting_x += text_layer.width
		starting_y += text_layer.height #increment it for next round/line
	textlayer.visible = False	
	pdb.gimp_image_remove_layer(image, textlayer)
	#pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
################################### END ##########################################################################
	
def centered(image,layer):

	wh = pdb.gimp_drawable_width(layer)
	hh = pdb.gimp_drawable_height(layer)
	w = pdb.gimp_image_width(image)
	h = pdb.gimp_image_height(image)
	pdb.gimp_image_set_active_layer(image,layer)
	centerx=w/2
	centery=h/2
	adw=wh/2
	adh=hh/2
	sw=centerx - adw
	sh=centery - adh		
	pdb.gimp_layer_set_offsets(layer, sw, sh)

################### Selection to neon glow effect by BdR based in part on Glow Rel 1 by Tin Tran (http://bakon.ca/gimplearn)#################	
def python_neonglow(image, layer, glowcolor, glowsize):
	pdb.gimp_image_undo_group_start(image)
	# prepare for clean up later
	prev_layer = image.active_layer
	
	# gaussian blur sizes (example 45px, 30px 15px)
	glowsize2 = (glowsize * 2) / 3
	glowsize3 = glowsize / 3
	grow = glowsize / 15

	is_selection, x1, y1, x2, y2 = pdb.gimp_selection_bounds(image)
	
	if not (is_selection):
		pdb.gimp_message('There is nothing selected, create a selected region and try again.')
	else:
		# copy selection to new layer
		pdb.gimp_edit_copy(image.active_layer)
		glowarea = pdb.gimp_edit_paste(layer, False)
		pdb.gimp_floating_sel_to_layer(glowarea)
		pdb.gimp_image_select_item(image,CHANNEL_OP_REPLACE,image.active_layer)
		image.active_layer.name = "Glow highlight area"

		# adds small outerglow layer
		glowlayer1 = pdb.gimp_layer_new(image,image.width,image.height,RGBA_IMAGE,"outer glow",100,LAYER_MODE_NORMAL_LEGACY)
		pdb.gimp_image_insert_layer(image,glowlayer1,None,1)
		pdb.gimp_selection_grow(image,grow)
		pdb.gimp_context_set_foreground(glowcolor)
		pdb.gimp_edit_fill(glowlayer1,FOREGROUND_FILL)
		pdb.gimp_selection_none(image)
		pdb.plug_in_gauss(image,glowlayer1,glowsize,glowsize,1)
		image.active_layer.name = "Outer glow 1"
		
		#dodge outerglow copy
		glowlayer2 = pdb.gimp_layer_new_from_drawable(glowlayer1,image)
		pdb.gimp_image_insert_layer(image,glowlayer2,None,0)
		pdb.plug_in_gauss(image,glowlayer2,glowsize2,glowsize2,1)
		pdb.gimp_layer_set_mode(glowlayer2,DODGE_MODE)
		image.active_layer.name = "Outer glow 2"

		glowlayer3 = pdb.gimp_layer_new_from_drawable(glowlayer2,image)
		pdb.gimp_image_insert_layer(image,glowlayer3,None,1)
		pdb.plug_in_gauss(image,glowlayer3,glowsize3,glowsize3,1)
		pdb.gimp_layer_set_mode(glowlayer3,DODGE_MODE)
		image.active_layer.name = "Outer glow 3"
		pdb.gimp_image_raise_item_to_top(image, layer)
		pdb.gimp_image_merge_visible_layers(image, 0)
		pdb.gimp_image_undo_group_end(image)
################################################################################################################################################
		
global apply_layers
apply_layers = []
	
def check_layers(layer):
	apply_layers.append(layer)
	
def combine(image,layer):
	pdb.gimp_image_undo_group_start(image)
	layer = image.layers[-1]
	pdb.gimp_image_set_active_layer(image,layer)
	for currentlayer in image.layers:
		check_layers(currentlayer)	
	parent = pdb.gimp_item_get_parent(layer)
	name = pdb.gimp_item_get_name(layer)
	position = pdb.gimp_image_get_item_position(image , layer)
	pdb.gimp_edit_copy(layer)
	copy = pdb.gimp_edit_paste(layer ,1)
	pdb.gimp_floating_sel_to_layer(copy)
	pdb.gimp_image_raise_item_to_top(image, copy)
	for layer in apply_layers:
		pdb.gimp_item_set_visible(layer, 1)	
		parent = pdb.gimp_item_get_parent(layer)
		position = pdb.gimp_image_get_item_position(image, layer)
		new_layer = pdb.gimp_layer_new_from_drawable(copy, image)
		pdb.gimp_image_insert_layer(image,new_layer,parent,position)
		pdb.gimp_image_raise_item(image, layer)
		pdb.gimp_image_merge_down(image, layer, EXPAND_AS_NECESSARY)
	pdb.gimp_image_remove_layer(image, copy)
	pdb.gimp_image_undo_group_end(image)
	
def overlay_layer(image,layer):
	pdb.gimp_image_undo_group_start(image)
	#layer = image.layers[-1]
	pdb.gimp_image_set_active_layer(image,layer)
	for currentlayer in image.layers:
		check_layers(currentlayer)
	parent = pdb.gimp_item_get_parent(layer)
	name = pdb.gimp_item_get_name(layer)
	position = pdb.gimp_image_get_item_position(image , layer)
	pdb.gimp_edit_copy(layer)
	copy = pdb.gimp_edit_paste(layer ,1)
	pdb.gimp_floating_sel_to_layer(copy)
	pdb.gimp_image_raise_item_to_top(image, layer)
	for layer in image.layers:
		pdb.gimp_item_set_visible(layer, 1)	
		parent = pdb.gimp_item_get_parent(layer)
		position = pdb.gimp_image_get_item_position(image, layer)
		new_layer = pdb.gimp_layer_new_from_drawable(copy, image)
		pdb.gimp_image_insert_layer(image,new_layer,parent,position)
		pdb.gimp_image_merge_down(image, new_layer, EXPAND_AS_NECESSARY)	
	pdb.gimp_image_remove_layer(image, image.layers[0])
	pdb.gimp_image_remove_layer(image, image.layers[-1])	
	pdb.gimp_image_undo_group_end(image)

def bump_text(image, layer):
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_selection_none(image)
	pdb.gimp_layer_resize_to_image_size(layer)
	pdb.gimp_image_select_item(image,CHANNEL_OP_REPLACE,layer)
	pdb.gimp_selection_feather(image,15)
	channel = pdb.gimp_selection_save(image)
	pdb.gimp_selection_none(image)
	azimuth = 45
	pdb.plug_in_bump_map(image,layer,channel,azimuth,27,65,0,0,0,0.5,True,False,1)
	pdb.gimp_image_undo_group_end(image)
	
def MrQ_animated_scene(image, layer, fill, background_c, pattern, source_bg, type_resize,
	type_create_back, source_back, font_name_b, font_size_b, text_b, align_back, type_fill_b, text_b_color, pattern_b, add_efect, bump_text_b,glow_b, glowcolor_b, glowsize_b,
	type_create, source, font_name_f, font_size_f, text_f, type_fill_f, text_f_color, pattern_f, add_efect_f, bump_text_f, glow_f, glowcolor_f, glowsize_f,type_anim,
	overlay, source_overlay, autocrop_over, centered_over, mir1, mir2, mir3, mir4, mir_offset, scale_over,	
	margin_x, margin_y, frames, reverse, ping_pong, inScale, regex, play,
	help, ptab):

	new_image = gimp.Image(100, 100, RGB)

	background_layer = pdb.gimp_layer_new(new_image, 100,100, RGBA_IMAGE, "Background Layer", 100, LAYER_MODE_NORMAL_LEGACY)
	pdb.gimp_image_insert_layer(new_image, background_layer, None, -1)
	if fill==5:		# LOAD FROM Layer
		over = pdb.gimp_layer_new_from_drawable(source_bg, new_image)
		pdb.gimp_image_insert_layer(new_image, over, None, -1)
		pdb.gimp_item_set_visible(over, 1)
		background_layer=over
		if type_resize==0:
			#pdb.gimp_layer_resize_to_image_size(over)
			pdb.gimp_image_resize_to_layers(new_image)

		pdb.gimp_image_lower_item_to_bottom(new_image,over)
		pdb.gimp_image_raise_item(new_image, over)
		pdb.gimp_item_set_visible(over, 1)		
		background_layer=pdb.gimp_image_merge_down(new_image, over, 0)	
	if type_fill_b==0:
		gimp.set_foreground(text_b_color)
		
	if type_create_back==0:	
		text_layer_b = pdb.gimp_text_fontname(new_image, None, 0, 0, text_b, 0, 1, font_size_b, PIXELS, font_name_b )
		pdb.gimp_text_layer_set_justification (text_layer_b, 2)

		
	if type_create_back==1:	
		item_copy_b = pdb.gimp_layer_new_from_drawable(source_back, new_image)
		text_layer_b=pdb.gimp_image_insert_layer(new_image, item_copy_b , None, -1)
		pdb.gimp_item_set_visible(item_copy_b, 1)
		text_layer_b=item_copy_b

	if type_fill_f==0:
		gimp.set_foreground(text_f_color)		
	
	if type_create==1:		# LOAD FROM 

		item_copy = pdb.gimp_layer_new_from_drawable(source, new_image)
		text_layer_f=pdb.gimp_image_insert_layer(new_image, item_copy, None, -1)
		text_layer_f=item_copy
		
	if type_create==0:	
		text_layer_f = pdb.gimp_text_fontname(new_image, None, 0, 0, text_f, 0, 1, font_size_f, PIXELS, font_name_f)
		pdb.gimp_text_layer_set_justification (text_layer_f, 2)

	pdb.gimp_image_resize_to_layers(new_image)
	pdb.gimp_image_resize(new_image, new_image.width+2*margin_x,new_image.height+2*margin_y, 0,0)
	if type_create_back!=2:
		centered(new_image,text_layer_b)
		if align_back==1:	# Top
			pdb.gimp_image_set_active_layer(new_image,text_layer_b)
			a,b = pdb.gimp_drawable_offsets(text_layer_b)
			pdb.gimp_layer_set_offsets (text_layer_b,a,glowsize_b/2)		
		if align_back==2:
			pdb.gimp_image_set_active_layer(new_image,text_layer_b)
			a,b = pdb.gimp_drawable_offsets(text_layer_b)
			pdb.gimp_layer_set_offsets (text_layer_b, a ,new_image.height - text_layer_b.height - glowsize_b/2) 		
	pdb.gimp_layer_resize_to_image_size(background_layer)
	centered(new_image,text_layer_f)
	
	pdb.gimp_layer_resize_to_image_size(text_layer_f)
		
	if fill==0:
		gimp.set_foreground((0,0,0))
		fill_type=FILL_FOREGROUND
	if fill==1:
		fill_type=FILL_WHITE		
	if fill==2:
		gimp.set_foreground(background_c)
		fill_type=FILL_FOREGROUND
	if fill==3:
		fill_type=FILL_TRANSPARENT
	if fill==4:
		pdb.gimp_context_set_pattern(pattern)
		fill_type=FILL_PATTERN
	if fill<5:	
		pdb.gimp_drawable_fill(background_layer, fill_type)
	if fill==5 and type_resize!=0:		# LOAD FROM Layer
		over = pdb.gimp_layer_new_from_drawable(source_bg, new_image)
		pdb.gimp_image_insert_layer(new_image, over, None, -1)
		pdb.gimp_item_set_visible(over, 1)
		background_layer=over

		if type_resize==1:
			pdb.gimp_layer_scale(over, new_image.width, new_image.height, 0)
			
		if type_resize==2:
			wo = pdb.gimp_drawable_width(over)
			ho = pdb.gimp_drawable_height(over)
			for layer in new_image.layers:
				pdb.gimp_layer_scale(layer, wo, ho, 0)
				centered (new_image,layer)
			pdb.gimp_image_resize_to_layers(new_image)	

		pdb.gimp_image_lower_item_to_bottom(new_image,over)
		pdb.gimp_image_raise_item(new_image, over)
		pdb.gimp_item_set_visible(over, 1)		
		background_layer=pdb.gimp_image_merge_down(new_image, over, 0)	

		
	pdb.gimp_item_set_visible(background_layer, 0)
	pdb.gimp_item_set_visible(text_layer_f, 0)
		
			
	if type_fill_b==1 and type_create_back!=2:
		pdb.gimp_image_select_item(new_image, 2, text_layer_b)
		pdb.gimp_context_set_pattern(pattern_b)
		pdb.gimp_edit_fill(text_layer_b, FILL_PATTERN)
		pdb.gimp_selection_none(new_image)	

	if add_efect!=0 and type_create_back!=2:
		pdb.gimp_image_set_active_layer(new_image,text_layer_b)
		pdb.gimp_image_select_item(new_image, 2, text_layer_b)	

		if add_efect==1:	# Camouflage
			pdb.plug_in_gmic_qt(new_image,text_layer_b, 1, 0, 'fx_camouflage 9,12,100,30,46,33,75,90,65,179,189,117,255,246,158')
		if add_efect==2:	# canvas			
			gegl_anim(new_image, text_layer_b, 'texturize-canvas')
		if add_efect==3:	# crystal
			pdb.plug_in_gmic_qt(new_image,text_layer_b, 1, 0, 'fx_crystal_background 10,25,0,100,1')			
		if add_efect==4:	# cubism			
			gegl_anim(new_image, text_layer_b, 'cubism')
		if add_efect==5:	# Denim
			pdb.plug_in_gmic_qt(new_image,text_layer_b, 1, 0,'Denim_samj 5,2,0,40,40,25,50,0,43,108,126,255')
		if add_efect==6: # dirty 
			pdb.plug_in_gmic_qt(new_image,text_layer_b, 1, 0, 'fx_dirty 30,1,0,0,0,50,50')		
		if add_efect==7:	# edge			
			gegl_anim(new_image, text_layer_b, 'edge')
		if add_efect==8:	# edge-neon			
			gegl_anim(new_image, text_layer_b, 'edge-neon')		
		if add_efect==9:	# edge-sobel		
			gegl_anim(new_image, text_layer_b, 'edge-sobel')	
		if add_efect==10:	# engrave rgb-clip	
			gegl_anim(new_image, text_layer_b, 'engrave rgb-clip')
		if add_efect==11:	# gradmap		
			pdb.plug_in_gradmap(new_image, text_layer_b)		
		if add_efect_f==12:	# Grid Cartesian
			grid_x=1+font_size_b/10	
			grid_y=1+font_size_b/10	       
			pdb.plug_in_gmic_qt(new_image,text_layer_b, 1, 0,"fx_imagegrid "+str(grid_x)+","+ str(grid_y))
		if add_efect_f==13:	# Grid Triangular
			grid_x=8+font_size_b/10	
			grid_y=8+font_size_b/10	       
			pdb.plug_in_gmic_qt(new_image,text_layer_b, 1, 0,"fx_imagegrid_triangular "+str(grid_x)+","+ str(grid_y)+",2,255,255,255,128")				
		if add_efect==14:	# Ministeck
			pdb.gimp_selection_none(new_image)
			pdb.gimp_layer_resize_to_image_size(text_layer_b)
			layer_copy_s = pdb.gimp_layer_new_from_drawable(text_layer_b, new_image)
			if type_fill_b==0:
				gimp.set_foreground(text_b_color)
				pdb.gimp_drawable_fill(layer_copy_s, FILL_FOREGROUND)		
			pdb.gimp_image_insert_layer(new_image, layer_copy_s, None,-1)

			if type_fill_b==1:			
				pdb.gimp_context_set_pattern(pattern_b)
				pdb.gimp_drawable_fill(layer_copy_s, FILL_PATTERN)
				pdb.gimp_selection_none(new_image)			
			pdb.gimp_image_set_active_layer(new_image,layer_copy_s)
			lcw=layer_copy_s.width
			lch=layer_copy_s.height
			piece_size=	20
			pdb.plug_in_gmic_qt(new_image,layer_copy_s, 1, 0,"fx_ministeck 24,256,"+ str(piece_size)+ ",2,200,0.3,1")
			pdb.gimp_image_crop(new_image, lcw, lch, 0, 0)
			pdb.gimp_image_select_item(new_image,0,text_layer_b)
			pdb.gimp_selection_invert(new_image)	
			pdb.gimp_drawable_edit_clear(new_image.layers[1])
			mini_steck=pdb.gimp_image_merge_down(new_image, new_image.layers[1], 0)
			text_layer_b=mini_steck
			
		if add_efect==15:	# mosaic
			pdb.plug_in_gmic_qt(new_image,text_layer_b, 1, 0,"fx_plasma 0.5,0,8,1,0,128,128,128")
		if add_efect==16:	# pixelize
			gegl_anim(new_image, text_layer_b, 'pixelize')		
		if add_efect==17:	# plasma
			pdb.plug_in_gmic_qt(new_image,text_layer_b, 1, 0,"fx_plasma 0.5,0,8,1,0,128,128,128")
		if add_efect==18:	# rainbow
			pdb.plug_in_gmic_qt(new_image,text_layer_b, 1, 0, 'fx_rep_rainbowify 0,0,100,0,50,50')
		if add_efect==19: # superpixels Colors average
			size_pix=font_size_b/20
			pdb.plug_in_gmic_qt(new_image,text_layer_b, 1, 0, 'fx_superpixels ' + str(size_pix)+ ',0,10,1,1,0,0,0,255,0,50,50')	
		if add_efect==20: # superpixels colors random 
			size_pix=font_size_b/20
			pdb.plug_in_gmic_qt(new_image,text_layer_b, 1, 0, 'fx_superpixels ' + str(size_pix)+ ',0,10,0,1,0,0,0,255,0,50,50')
		if add_efect==21:	# video-degradation	
			gegl_anim(new_image, text_layer_b, 'video-degradation pattern=wide-striped additive=0')
		
	pdb.gimp_selection_none(new_image)

	if bump_text_b and type_create_back!=2:	
		bump_text(new_image,text_layer_b)

	if glow_b and type_create_back!=2:
		pdb.gimp_image_select_item(new_image, 2, text_layer_b)
		pdb.gimp_image_set_active_layer(new_image,text_layer_b)
		python_neonglow(new_image,text_layer_b, glowcolor_b, glowsize_b)# (200,20,20),30)
		
	if type_fill_f==1:
		pdb.gimp_image_select_item(new_image, 2, text_layer_f)
		pdb.gimp_context_set_pattern(pattern_f)
		pdb.gimp_edit_fill(text_layer_f, FILL_PATTERN)
		pdb.gimp_selection_none(new_image)
		
	pdb.gimp_item_set_visible(background_layer, 1)
	mer = pdb.gimp_image_merge_visible_layers(new_image, 0)
	#pdb.gimp_item_set_visible(mer, 1)
		
	pdb.gimp_item_set_visible(mer, 0)
	pdb.gimp_item_set_visible(text_layer_f, 1)

	if add_efect_f!=0:
		pdb.gimp_image_set_active_layer(new_image,text_layer_f)
		pdb.gimp_image_select_item(new_image, 2, text_layer_f)	

	if add_efect_f==1:	# Camouflage
		pdb.plug_in_gmic_qt(new_image,text_layer_f, 1, 0, 'fx_camouflage 9,12,100,30,46,33,75,90,65,179,189,117,255,246,158')
	if add_efect_f==2:	# canvas			
		gegl_anim(new_image, text_layer_f, 'texturize-canvas')
	if add_efect_f==3:	# crystal
		pdb.plug_in_gmic_qt(new_image,text_layer_f, 1, 0, 'fx_crystal_background 10,25,0,100,1')			
	if add_efect_f==4:	# cubism			
		gegl_anim(new_image, text_layer_f, 'cubism')
	if add_efect_f==5:	# Denim
		pdb.plug_in_gmic_qt(new_image,text_layer_f, 1, 0,'Denim_samj 5,2,0,40,40,25,50,0,43,108,126,255')
	if add_efect_f==6: # dirty 
		pdb.plug_in_gmic_qt(new_image,text_layer_f, 1, 0, 'fx_dirty 30,1,0,0,0,50,50')		
	if add_efect_f==7:	# edge			
		gegl_anim(new_image, text_layer_f, 'edge')
	if add_efect_f==8:	# edge-neon			
		gegl_anim(new_image, text_layer_f, 'edge-neon')		
	if add_efect_f==9:	# edge-sobel		
		gegl_anim(new_image, text_layer_f, 'edge-sobel')	
	if add_efect_f==10:	# engrave rgb-clip	
		gegl_anim(new_image, text_layer_f, 'engrave rgb-clip')
	if add_efect_f==11:	# gradmap
		pdb.plug_in_gradmap(new_image, text_layer_f)
	if add_efect_f==12:	# Grid Cartesian
		grid_x=1+font_size_f/10	
		grid_y=1+font_size_f/10	       
		pdb.plug_in_gmic_qt(new_image,text_layer_f, 1, 0,"fx_imagegrid "+str(grid_x)+","+ str(grid_y))	
	if add_efect_f==13:	# Grid Triangular
		grid_x=8+font_size_f/10	
		grid_y=8+font_size_f/10	       
		pdb.plug_in_gmic_qt(new_image,text_layer_f, 1, 0,"fx_imagegrid_triangular "+str(grid_x)+","+ str(grid_y)+",2,255,255,255,128")		
	if add_efect_f==14:	# Ministeck
		pdb.gimp_selection_none(new_image)
		pdb.gimp_layer_resize_to_image_size(text_layer_f)
		layer_copy_s = pdb.gimp_layer_new_from_drawable(text_layer_f, new_image)
		if type_fill_b==0:
			gimp.set_foreground(text_b_color)
			pdb.gimp_drawable_fill(layer_copy_s, FILL_FOREGROUND)		
		pdb.gimp_image_insert_layer(new_image, layer_copy_s, None,-1)

		if type_fill_b==1:			
			pdb.gimp_context_set_pattern(pattern_f)
			pdb.gimp_drawable_fill(layer_copy_s, FILL_PATTERN)
			pdb.gimp_selection_none(new_image)			
		pdb.gimp_image_set_active_layer(new_image,layer_copy_s)
		lcw=layer_copy_s.width
		lch=layer_copy_s.height
		piece_size=	20
		pdb.plug_in_gmic_qt(new_image,layer_copy_s, 1, 0,"fx_ministeck 24,256,"+ str(piece_size)+ ",2,200,0.3,1")
		pdb.gimp_image_crop(new_image, lcw, lch, 0, 0)
		pdb.gimp_image_select_item(new_image,0,text_layer_f)
		pdb.gimp_selection_invert(new_image)	
		pdb.gimp_drawable_edit_clear(new_image.layers[0])
		mini_steck=pdb.gimp_image_merge_down(new_image, new_image.layers[0], 0)
		text_layer_f=mini_steck	
		
	if add_efect_f==15:	# mosaic
		pdb.plug_in_gmic_qt(new_image,text_layer_f, 1, 0,"fx_plasma 0.5,0,8,1,0,128,128,128")
	if add_efect_f==16:	# pixelize
		gegl_anim(new_image, text_layer_f, 'pixelize')		
	if add_efect_f==17:	# plasma
		pdb.plug_in_gmic_qt(new_image,text_layer_f, 1, 0,"fx_plasma 0.5,0,8,1,0,128,128,128")
	if add_efect_f==18:	# rainbow
		pdb.plug_in_gmic_qt(new_image,text_layer_f, 1, 0, 'fx_rep_rainbowify 0,0,100,0,50,50')
	if add_efect_f==19: # superpixels Colors average
		size_pix=font_size_b/20
		pdb.plug_in_gmic_qt(new_image,text_layer_f, 1, 0, 'fx_superpixels ' + str(size_pix)+ ',0,10,1,1,0,0,0,255,0,50,50')	
	if add_efect_f==20: # superpixels colors random 
		size_pix=font_size_b/20
		pdb.plug_in_gmic_qt(new_image,text_layer_f, 1, 0, 'fx_superpixels ' + str(size_pix)+ ',0,10,0,1,0,0,0,255,0,50,50')		
	if add_efect_f==21:	# video-degradation	
		gegl_anim(new_image, text_layer_f, 'video-degradation pattern=wide-striped additive=0')
		
	pdb.gimp_selection_none(new_image)

	if bump_text_f:			
		bump_text(new_image,text_layer_f)
		
	if glow_f:
		pdb.gimp_image_select_item(new_image, 2, text_layer_f)
		pdb.gimp_image_set_active_layer(new_image,text_layer_f)
		python_neonglow(new_image,text_layer_f, glowcolor_f, glowsize_f)# (200,20,20),30)
		
	layer_gm = pdb.gimp_image_merge_visible_layers(new_image, 0)
	
	if type_anim==0:

		for x in range(1,int(frames)):
			am =x*360/int(frames) # angle 0-360
			of =x*500/int(frames) # offset 0-500
			pdb.gimp_image_set_active_layer(new_image,layer_gm)
			pdb.plug_in_gmic_qt(new_image, layer_gm, 1, 1, "-ripple 20,200,2,"+ str(am) + "," + str(of))
			
	if type_anim==1 or type_anim==2:
	
		pdb.plug_in_autocrop_layer(new_image, layer_gm)
		a,b = pdb.gimp_drawable_offsets(layer_gm)
		wl = pdb.gimp_drawable_width(layer_gm)
		wI = pdb.gimp_image_width(new_image)
		pdb.gimp_layer_set_offsets(layer_gm,-wl,b)
		inc = float(2*wI/int(frames))

		x=0
		for x in range(0,int(frames)):
		
			layer_gm.visible = True
			pdb.gimp_layer_set_offsets(layer_gm, -wl + (x+1)*inc,b)
			frame_layer = pdb.gimp_layer_new_from_visible(new_image,new_image,"frame")
			pdb.gimp_image_insert_layer(new_image,frame_layer,None,0)
			frame_layer.visible = False
			
			if type_anim==2:	# Ripple & Sliding
			
				layer_gm.visible = False			
				am =x*360/int(frames) # angle 0-360
				of =x*500/int(frames) # offset 0-500
				pdb.plug_in_gmic_qt(new_image, frame_layer, 1, 0, "-ripple 20,200,2,"+ str(am) + "," + str(of))

		pdb.gimp_layer_resize_to_image_size(new_image.layers[int(frames)])			
		pdb.gimp_image_remove_layer(new_image, new_image.layers[0])

	if type_anim==3:
		
		for x in range(1,int(frames)):
			cr =200-x*200/int(frames) # amplitude 0-200
			pdb.plug_in_gmic_qt(new_image, layer_gm, 1, 1, "fx_crease "+ str(cr) + ",100,0")
		pdb.gimp_image_raise_item_to_top(new_image, layer_gm)
		
			
	if type_anim==4: # zoom
		pdb.gimp_image_set_active_layer(new_image,layer_gm)
		for x in range(1,int(frames)):
			zm=1.000 - 1.0000*x/int(frames)
			pdb.plug_in_gmic_qt(new_image, layer_gm, 1, 1, "fx_zoom "+ str(zm) + ",50,50,0")			
		
	if type_anim==5: # rotate	
		rotate_angle=0
		w = pdb.gimp_drawable_width(layer_gm)
		h = pdb.gimp_drawable_height(layer_gm)		
		for x in range(1,int(frames)):
			inc_angle=360/frames
			rotate_angle=rotate_angle + inc_angle
			pdb.gimp_image_get_active_layer(new_image)
			copy = pdb.gimp_layer_copy(layer_gm, TRUE)
			pdb.gimp_image_insert_layer(new_image, copy, None, -1)
			pdb.gimp_item_transform_rotate(copy, rotate_angle*0.01745329252 ,FALSE, w/2, h/2)
			pdb.gimp_layer_resize_to_image_size(copy)

	if type_anim==6:
		copy = pdb.gimp_layer_copy(layer_gm, TRUE)
		pdb.gimp_image_remove_layer(new_image, layer_gm)
		
		gimp.set_foreground(text_f_color)
		text_layer_f = pdb.gimp_text_fontname(new_image, None, 0, 0, text_f, 0, 1, font_size_f, PIXELS, font_name_f)
		pdb.gimp_text_layer_set_justification (text_layer_f, 2)
		centered(new_image,text_layer_f)
		python_character_layers_from_text(new_image,text_layer_f)
		
		for layer in new_image.layers:
			if bump_text_f:	
				bump_text(new_image,layer)
			pdb.gimp_item_set_visible(layer, 0)
			pdb.gimp_image_set_active_layer(new_image,layer)
			pdb.gimp_image_raise_item_to_top(new_image, layer)

		pdb.gimp_image_lower_item_to_bottom(new_image,new_image.layers[0])	
		for layer in new_image.layers:
			pdb.gimp_item_set_visible(layer, 1)
			frame_layer = pdb.gimp_layer_new_from_visible(new_image,new_image,"frame")
			pdb.gimp_image_insert_layer(new_image,frame_layer,None,0)
			pdb.gimp_image_lower_item_to_bottom(new_image,layer)
			pdb.gimp_image_lower_item_to_bottom(new_image,frame_layer)
			pdb.gimp_image_merge_down(new_image, layer, 0)
			
		for layer in new_image.layers:
			pdb.gimp_image_set_active_layer(new_image,layer)
			pdb.gimp_image_raise_item_to_top(new_image, layer)
		pdb.gimp_image_set_active_layer(new_image,new_image.layers[0])
		pdb.gimp_image_lower_item_to_bottom(new_image,new_image.layers[0])
		pdb.gimp_image_insert_layer(new_image, copy, None, 0)
		pdb.gimp_image_raise_item_to_top(new_image, copy)
		combine(new_image,new_image.layers[-1])
		
	if type_anim==7:
		pdb.gimp_image_select_item(new_image,CHANNEL_OP_REPLACE,layer_gm)
		pdb.gimp_image_set_active_layer(new_image,layer_gm)
		pdb.plug_in_gmic_qt(new_image, layer_gm, 1, 1, "fx_fire_edges 0.7,0.25,0.5,25,"+ str(int(frames)) +",10,10,0,50,50")
		pdb.gimp_selection_none(new_image)
		pdb.gimp_image_remove_layer(new_image,layer_gm)

	if type_anim==8:	# Deform
		for x in range(1,int(frames)):
			of =x*10.0/int(frames) 
			pdb.gimp_image_set_active_layer(new_image,layer_gm)
			pdb.plug_in_gmic_qt(new_image, layer_gm, 1, 1, "deform " +str(of))

	if type_anim==9:	# From Top to Bottom
	
		pdb.plug_in_autocrop_layer(new_image, layer_gm)
		a,b = pdb.gimp_drawable_offsets(layer_gm)
		wh = pdb.gimp_drawable_height(layer_gm)
		wH = pdb.gimp_image_height(new_image)
		pdb.gimp_layer_set_offsets(layer_gm,a,-wh)
		inc = float(2*wH/int(frames))

		x=0
		for x in range(0,int(frames)):
		
			layer_gm.visible = True
			pdb.gimp_layer_set_offsets(layer_gm,a, -wh + (x+1)*inc)
			frame_layer = pdb.gimp_layer_new_from_visible(new_image,new_image,"frame")
			pdb.gimp_image_insert_layer(new_image,frame_layer,None,0)
			frame_layer.visible = False

		pdb.gimp_layer_resize_to_image_size(new_image.layers[int(frames)])			
		pdb.gimp_image_remove_layer(new_image, new_image.layers[0])

	if type_anim==10:
		
		for x in range(0,int(frames)):
			moz=font_size_f/10
			tile_size= moz + x*20/int(frames) 			# 5-200
			tile_spacing=moz/5 + x*20/int(frames)		# 0.5-30
			object_spred=0.05+x*0.05/int(frames)

			#layer_copy_s = pdb.gimp_layer_new_from_drawable(new_image.layers[0], new_image)
			layer_copy_s=pdb.gimp_layer_new_from_visible(new_image,new_image,"frame")
			pdb.gimp_item_set_visible(layer_gm, 0)
			pdb.gimp_image_insert_layer(new_image, layer_copy_s, None,-1)
			pdb.gimp_item_set_visible(layer_gm, 0)
			pdb.gimp_image_lower_item(new_image, layer_copy_s)
			
			if x==0:
				pdb.gimp_image_select_item(new_image, 2, layer_copy_s)
				pdb.gimp_selection_grow(new_image,2)
				pdb.gimp_selection_border(new_image, 4)
				pdb.gimp_context_set_gradient("Incandescent")
				pdb.gimp_context_set_gradient_reverse(True)
				wh = pdb.gimp_drawable_width(layer_copy_s)
				hh = pdb.gimp_drawable_height(layer_copy_s)
				pdb.gimp_drawable_edit_gradient_fill(layer_copy_s, 2, 0, 0, 1, 0, False, wh/2, hh/2, wh/2, hh/2+wh/2)
				pdb.gimp_selection_none(new_image)
				
			pdb.gimp_image_select_item(new_image, 2, layer_copy_s)
			gegl_anim(new_image, layer_copy_s, 'mosaic tile-type=octagons tile-size=%f tile-height=10.0 tile-neatness=0.5 color-variation=0 color-averaging=0 tile-surface=0 tile-allow-split=0 tile-spacing=%f antialiasing=1' % (tile_size, tile_spacing))
			pdb.gimp_selection_none(new_image)			
			pdb.gimp_image_select_color(new_image, 2, layer_copy_s, (0,0,0))
			pdb.gimp_selection_grow(new_image, 1+x*10/int(frames))
			pdb.gimp_edit_clear(layer_copy_s)
			pdb.gimp_item_set_visible(layer_copy_s, 1)					
			pdb.gimp_selection_none(new_image)
			pdb.gimp_image_set_active_layer(new_image,layer_copy_s)	
			pdb.plug_in_gmic_qt(new_image,layer_copy_s, 1, 0, "fx_zoom 1.1,50,50,0")
			pdb.plug_in_gmic_qt(new_image,layer_copy_s, 1, 0, "fx_breaks 0,32.7,35.4,1.93,3")		
			gegl_anim(new_image, layer_copy_s,"motion-blur-zoom center-x=0.5 center-y=0.5 factor=%f" % (object_spred))
			pdb.gimp_selection_none(new_image)
			pdb.gimp_layer_set_opacity(layer_copy_s, 100-x*30/int(frames))
			
			if x>0:
				pdb.gimp_item_set_visible(new_image.layers[1],0)
				
		for layer in new_image.layers:
			pdb.gimp_image_set_active_layer(new_image,layer)
			pdb.gimp_image_raise_item_to_top(new_image, layer)
			
		pdb.gimp_image_lower_item_to_bottom(new_image,new_image.layers[0])
		
	if type_anim==11:	# Raindrops
		for x in range(0,int(frames)):
			density =0.250+ x*0.500/int(frames)
			wavelenght =0.50+ x*0.500/int(frames)			
			pdb.gimp_image_set_active_layer(new_image,layer_gm)
			pdb.plug_in_gmic_qt(new_image, layer_gm, 1, 1, "raindrops 150," + str(density) + "," + str(wavelenght) + ",4")
			
	if type_anim==12:	# Scanlines	
		for x in range(0,int(frames)):
			pdb.gimp_image_select_item(new_image, 2, layer_gm)
			bandwidth =5+ x*15.00/int(frames)
			pdb.gimp_image_set_active_layer(new_image,layer_gm)
			pdb.plug_in_gmic_qt(new_image, layer_gm, 1, 1, "fx_scanlines 60," + str(bandwidth) + ",0,0,0,0,0,0,50,50")
			pdb.gimp_selection_none(new_image)

	if type_anim==13:	# Wave	
		for x in range(0,int(frames)):
			amplitude =4.000 + x*25.000/int(frames)
			freqency =1.000 + x*1.000/int(frames)			
			pdb.gimp_image_set_active_layer(new_image,layer_gm)
			pdb.plug_in_gmic_qt(new_image, layer_gm, 1, 1, "wave "+ str(amplitude)+","+str(freqency) + ",50,50")
			pdb.gimp_selection_none(new_image)
			
	if type_anim==14:	# Water	
		for x in range(0,int(frames)):
			amplitude =10.000 + x*250.000/int(frames)
			smoth =4.000 - x*4.000/int(frames)
			angle=x*360.0/int(frames)
			pdb.gimp_image_set_active_layer(new_image,layer_gm)
			pdb.plug_in_gmic_qt(new_image, layer_gm, 1, 1, "water "+ str(amplitude)+","+str(smoth)+","+ str(angle))
			pdb.gimp_selection_none(new_image)
	
	if type_anim==15:	# Rotation about Y axis in degrees
		pdb.gimp_image_set_active_layer(new_image,layer_gm)
		
		maptype=0	# (0=plane,1=sphere,2=box,3=cylinder)
		rotationangle_x= 0.0       
		rotationangle_z= 0.0			
		ambient_intensity=0.3 ; diffuse_intensity=1.0 ; diffuse_reflectivity=0.5 ; specular_reflectivity=.05 ; highlight=27.0
		antialiasing = True
		tiled = False
		newimage = False   
		transparentbackground = True
		radius          =0.0 
		cylinder_length =0.03  
		cyl_bottom_drawable = new_image.layers[0]
		viewpoint_x  =   0.25 ; viewpoint_y  =   0.25  ; viewpoint_z  =  3.0  
		position_x   =   0.50 ; position_y   =   0.50  ; position_z   =  0.0  
		firstaxis_x  =   1.00 ; firstaxis_y  =   0.00  ; firstaxis_z  =  0.0  
		secondaxis_x =   0.00 ; secondaxis_y =   1.00  ; secondaxis_z =  0.0  
		x_scale=.0 ; y_scale=.0 ; z_scale=.0                                       
		box_front_drawable =None ; box_back_drawable=None ; box_top_drawable  =None 
		box_bottom_drawable=None ; box_left_drawable=None ; box_right_drawable=None  
		lighttype=2           ; lightcolor='#ffffff'  
		lightposition_x =-0.5 ; lightposition_y =-0.5 ; lightposition_z = 2.0    
		lightdirection_x=-1.0 ; lightdirection_y=-1.0 ; lightdirection_z=-1.0
		
		for x in range(1,int(frames)):
			cyl_top_drawable    = new_image.layers[0]
			rotationangle_y= 0.0 + x*180.0/int(frames)
			copy = pdb.gimp_layer_copy(layer_gm, TRUE)
			pdb.gimp_image_insert_layer(new_image, copy, None, 0)
			copy.name = 'map'
			pdb.gimp_image_set_active_layer(new_image,copy)
			pdb.plug_in_map_object(new_image, copy, maptype, viewpoint_x, viewpoint_y, viewpoint_z, position_x, position_y, position_z, firstaxis_x, firstaxis_y, firstaxis_z, secondaxis_x, secondaxis_y, secondaxis_z, rotationangle_x, rotationangle_y, rotationangle_z, lighttype, lightcolor, lightposition_x, lightposition_y, lightposition_z, lightdirection_x, lightdirection_y, lightdirection_z, ambient_intensity, diffuse_intensity, diffuse_reflectivity, specular_reflectivity, highlight, antialiasing, tiled, newimage, transparentbackground, radius, x_scale, y_scale, z_scale, cylinder_length, box_front_drawable, box_back_drawable, box_top_drawable, box_bottom_drawable, box_left_drawable, box_right_drawable, cyl_top_drawable, cyl_bottom_drawable)
		pdb.gimp_image_set_active_layer(new_image,new_image.layers[0])
		
		for x in range(1,int(frames)):
			cyl_top_drawable    = new_image.layers[0]	#top
			rotationangle_y= 0.0 + x*180.0/int(frames)
			copy = pdb.gimp_layer_copy(new_image.layers[0], TRUE)
			pdb.gimp_image_insert_layer(new_image, copy, None, 1)
			copy.name = 'map_r'
			pdb.gimp_image_set_active_layer(new_image,copy)
			pdb.plug_in_map_object(new_image, copy, maptype, viewpoint_x, viewpoint_y, viewpoint_z, position_x, position_y, position_z, firstaxis_x, firstaxis_y, firstaxis_z, secondaxis_x, secondaxis_y, secondaxis_z, rotationangle_x, rotationangle_y, rotationangle_z, lighttype, lightcolor, lightposition_x, lightposition_y, lightposition_z, lightdirection_x, lightdirection_y, lightdirection_z, ambient_intensity, diffuse_intensity, diffuse_reflectivity, specular_reflectivity, highlight, antialiasing, tiled, newimage, transparentbackground, radius, x_scale, y_scale, z_scale, cylinder_length, box_front_drawable, box_back_drawable, box_top_drawable, box_bottom_drawable, box_left_drawable, box_right_drawable, cyl_top_drawable, cyl_bottom_drawable)
		pdb.gimp_image_remove_layer(new_image, new_image.layers[0])

	if type_anim==16:	# Rotation about X axis in degrees
		pdb.gimp_image_set_active_layer(new_image,layer_gm)
		maptype=0	# (0=plane,1=sphere,2=box,3=cylinder)
		rotationangle_x= 0.0       
		rotationangle_y= 0.0			
		ambient_intensity=0.3 ; diffuse_intensity=1.0 ; diffuse_reflectivity=0.5 ; specular_reflectivity=.05 ; highlight=27.0
		antialiasing = True
		tiled = False
		newimage = False   
		transparentbackground = True
		radius          =0.0 
		cylinder_length =0.03  
		cyl_bottom_drawable = new_image.layers[0]
		viewpoint_x  =   0.25 ; viewpoint_y  =   0.25  ; viewpoint_z  =  3.0  
		position_x   =   0.50 ; position_y   =   0.50  ; position_z   =  0.0  
		firstaxis_x  =   1.00 ; firstaxis_y  =   0.00  ; firstaxis_z  =  0.0  
		secondaxis_x =   0.00 ; secondaxis_y =   1.00  ; secondaxis_z =  0.0  
		x_scale=.0 ; y_scale=.0 ; z_scale=.0                                       
		box_front_drawable =None ; box_back_drawable=None ; box_top_drawable  =None 
		box_bottom_drawable=None ; box_left_drawable=None ; box_right_drawable=None  
		lighttype=2           ; lightcolor='#ffffff'  
		lightposition_x =-0.5 ; lightposition_y =-0.5 ; lightposition_z = 2.0    
		lightdirection_x=-1.0 ; lightdirection_y=-1.0 ; lightdirection_z=-1.0
		
		for x in range(1,int(frames)):
			cyl_top_drawable    = new_image.layers[0]
			rotationangle_z= 0.0 + x*180.0/int(frames)
			copy = pdb.gimp_layer_copy(layer_gm, TRUE)
			pdb.gimp_image_insert_layer(new_image, copy, None, 0)
			copy.name = 'map'
			pdb.gimp_image_set_active_layer(new_image,copy)
			pdb.plug_in_map_object(new_image, copy, maptype, viewpoint_x, viewpoint_y, viewpoint_z, position_x, position_y, position_z, firstaxis_x, firstaxis_y, firstaxis_z, secondaxis_x, secondaxis_y, secondaxis_z, rotationangle_x, rotationangle_y, rotationangle_z, lighttype, lightcolor, lightposition_x, lightposition_y, lightposition_z, lightdirection_x, lightdirection_y, lightdirection_z, ambient_intensity, diffuse_intensity, diffuse_reflectivity, specular_reflectivity, highlight, antialiasing, tiled, newimage, transparentbackground, radius, x_scale, y_scale, z_scale, cylinder_length, box_front_drawable, box_back_drawable, box_top_drawable, box_bottom_drawable, box_left_drawable, box_right_drawable, cyl_top_drawable, cyl_bottom_drawable)
		pdb.gimp_image_set_active_layer(new_image,new_image.layers[0])
		
		for x in range(1,int(frames)):
			cyl_top_drawable    = new_image.layers[0]	#top
			rotationangle_z= 0.0 + x*180.0/int(frames)
			copy = pdb.gimp_layer_copy(new_image.layers[0], TRUE)
			pdb.gimp_image_insert_layer(new_image, copy, None, 1)
			copy.name = 'map_r'
			pdb.gimp_image_set_active_layer(new_image,copy)
			pdb.plug_in_map_object(new_image, copy, maptype, viewpoint_x, viewpoint_y, viewpoint_z, position_x, position_y, position_z, firstaxis_x, firstaxis_y, firstaxis_z, secondaxis_x, secondaxis_y, secondaxis_z, rotationangle_x, rotationangle_y, rotationangle_z, lighttype, lightcolor, lightposition_x, lightposition_y, lightposition_z, lightdirection_x, lightdirection_y, lightdirection_z, ambient_intensity, diffuse_intensity, diffuse_reflectivity, specular_reflectivity, highlight, antialiasing, tiled, newimage, transparentbackground, radius, x_scale, y_scale, z_scale, cylinder_length, box_front_drawable, box_back_drawable, box_top_drawable, box_bottom_drawable, box_left_drawable, box_right_drawable, cyl_top_drawable, cyl_bottom_drawable)
		pdb.gimp_image_remove_layer(new_image, new_image.layers[0])
		
	if type_anim==17:
			pdb.gimp_selection_none(new_image)
			pdb.gimp_layer_resize_to_image_size(layer_gm)
			pdb.plug_in_gmic_qt(new_image,layer_gm, 1, 0,"fx_crease 10.0,25.0,3")
			pdb.gimp_selection_none(new_image)

			for x in range(0,int(frames)):
				perturbation=10+x*5.0/int(frames)	# 0-15
				smoth=10+x*30.0/int(frames)	        # 0-100
				scale=1+x*10.0/int(frames)	        # 0-20
				sharpness=1+x*10.0/int(frames)	    # 0-1000				
				pdb.plug_in_gmic_qt(new_image,layer_gm, 1, 1,"fx_lava " +str(perturbation)+","+ str(smoth)+"," + str(scale)+"," + str(sharpness) + ",0,50,50")				
				pdb.plug_in_gmic_qt(new_image,layer_gm, 1, 0,"fx_crease 2.0,20.0,0")
				
	if type_anim==18:				
		WI = pdb.gimp_image_width(new_image)
		HI = pdb.gimp_image_height(new_image)
		pdb.plug_in_autocrop_layer(new_image, layer_gm)
		wl = pdb.gimp_drawable_width(new_image.layers[0])
		hl = pdb.gimp_drawable_height(new_image.layers[0])
		a,b = pdb.gimp_drawable_offsets(new_image.layers[0])
		pdb.gimp_layer_set_offsets(new_image.layers[0],-wl/2,-hl/2)
		wx=WI/int(frames)
		wy=HI/int(frames)
		for x in range(0,int(frames)):
			source_axis = pdb.gimp_layer_new_from_drawable(new_image.layers[0], new_image)
			pdb.gimp_image_insert_layer(new_image, source_axis , None, 1)
			pdb.gimp_layer_set_offsets(source_axis,x*wx,x*wy)			
			pdb.gimp_item_set_name(source_axis, "Source Axis")			
			pdb.gimp_layer_resize_to_image_size(source_axis)
			
	if type_anim==19:				
		WI = pdb.gimp_image_width(new_image)
		HI = pdb.gimp_image_height(new_image)
		pdb.plug_in_autocrop_layer(new_image, layer_gm)
		wl = pdb.gimp_drawable_width(new_image.layers[0])
		hl = pdb.gimp_drawable_height(new_image.layers[0])
		a,b = pdb.gimp_drawable_offsets(new_image.layers[0])
		pdb.gimp_layer_set_offsets(new_image.layers[0],WI,-hl/2)
		wx=WI/int(frames)
		wy=HI/int(frames)
		for x in range(0,int(frames)):
			source_axis = pdb.gimp_layer_new_from_drawable(new_image.layers[0], new_image)
			pdb.gimp_image_insert_layer(new_image, source_axis , None, 1)
			pdb.gimp_layer_set_offsets(source_axis,WI-x*wx-wl/2,x*wy-hl/2)			
			pdb.gimp_item_set_name(source_axis, "Source Axis")			
			pdb.gimp_layer_resize_to_image_size(source_axis)
			
	if type_anim!=6:			
		pdb.gimp_image_set_active_layer(new_image,mer)
		pdb.gimp_item_set_visible(mer, 1)
		combine(new_image,mer)
		
	if type_anim!=3 and type_anim!=6:
		pdb.gimp_image_remove_layer(new_image, new_image.layers[-1])
	if type_anim==17:
		pdb.gimp_image_remove_layer(new_image, new_image.layers[-1])	
	if reverse:
		for layer in new_image.layers:
			pdb.gimp_image_set_active_layer(new_image,layer)
			pdb.gimp_image_raise_item_to_top(new_image, layer)
			
	if ping_pong:
		for layer in new_image.layers:
			pdb.gimp_image_set_active_layer(new_image,layer)
			copy = pdb.gimp_layer_copy(layer, TRUE)
			pdb.gimp_image_insert_layer(new_image, copy, None, -1)			
			pdb.gimp_image_raise_item_to_top(new_image, layer)
			
	if overlay:
		source_over = pdb.gimp_layer_new_from_drawable(source_overlay, new_image)
		pdb.gimp_image_insert_layer(new_image, source_over , None, -1)
		pdb.gimp_image_lower_item_to_bottom(new_image,source_over)
		pdb.gimp_item_set_name(source_over, "Source overlay")
		
		if autocrop_over:
			pdb.plug_in_autocrop_layer(new_image, source_over)
		if centered_over:
			centered(new_image, source_over)
			
		if mir1: # " ALIGN TOP "
			pdb.gimp_image_set_active_layer(new_image,source_over)
			a,b = pdb.gimp_drawable_offsets(source_over)
			pdb.gimp_layer_set_offsets (source_over,a,mir_offset)
			
		if mir2: # " ALIGN BOTTOM "
			pdb.gimp_image_set_active_layer(new_image,source_over)
			a,b = pdb.gimp_drawable_offsets(source_over)
			pdb.gimp_layer_set_offsets (source_over, a ,new_image.height - source_over.height-mir_offset) 

		if mir3: # " ALIGN RIGHT "		
			pdb.gimp_image_set_active_layer(new_image,source_over)
			a,b = pdb.gimp_drawable_offsets(source_over)			
			pdb.gimp_layer_set_offsets (source_over,new_image.width-source_over.width-mir_offset, b)
			
		if mir4: # " ALIGN LEFT "
			pdb.gimp_image_set_active_layer(new_image,source_over)	
			a,b = pdb.gimp_drawable_offsets(source_over)
			pdb.gimp_layer_set_offsets (source_over, mir_offset, b)
			
		if scale_over:
			pdb.gimp_layer_scale(source_over, new_image.width, new_image.height, 1)
			centered(new_image, source_over)
			
		pdb.gimp_layer_resize_to_image_size(source_over)	
		overlay_layer(new_image,source_over)
		
	if inScale!=100:	
		for layer in new_image.layers:
			pdb.gimp_layer_scale(layer, layer.width*inScale/100, layer.height*inScale/100, 1)
		pdb.gimp_image_resize_to_layers(new_image)
			
# Rename ##########################################################################	
	pdb.gimp_image_undo_group_start(new_image)
	gimp.progress_init("Renaming layers")
	i = 1
	for l in reversed(new_image.layers):
		l.name = (regex) % i
		i += 1
	pdb.gimp_image_undo_group_end(new_image)
###################################################################################

	gimp.Display(new_image)

	#Play animation	
	if play:
		pdb.plug_in_animationplay(new_image, None)

help= "   *** If use: Background➤Resize Selected➤Not Resize ***\n Dimensions Back and Front must be smaller than this layer.\n (when You want to create an animation of the size loaded layer)"	\
+	"\n\n	  *** About Rename Layers: ***"	\
+	"\n\n %03d will change the number to have 3 digits,\n e.g. 001, 002 ... - 3 here is padding length.\n %02d ➤ 01, 02 ..."	\
+	"\n\n You can set how frames will be superimposed\n and select among options :"	\
+	"\n • Cumulative Layers (combine): previous frames will\n not be deleted when a new one is displayed."	\
+	"\n • One frame per layer (replace): previous frames will\n be deleted before displaying a new frame."	\
+	"\n\n\n Wish You have fun with this plugin:\n\n                                            MareroQ."	
   
register(
	"MrQ_animated_scene",
	" Create a animated scene. Ver.1.6.\n New Image Size = Max Text Size + Margin.",
	"Create a animated scene.\nRecommended use dingbat font",
	"MareroQ",
	"GPL",
	"2022",
	"Animated Text Scene...",
	"*",
	[
		(PF_IMAGE,    "image", "Input image", None),
		(PF_DRAWABLE, "layer", "Input layer", None),
		(PF_OPTION,   "fill",   "Type of Fill:", 0, ["Black","White","Color","Transparent","Pattern", "Load Selected Layer"]),
		(PF_COLOR,    "background_c", "Color:", (0,0,0),0),
		(PF_PATTERN,  "pattern", "Pattern:", "Crack",0,),		
		(PF_DRAWABLE, "source_bg", "Selected Layer ➤ ", None,0,),
		(PF_OPTION,   "type_resize",   "Resize Selected?", 1, ["Not Resize [*]","Scale Loaded Layer to Frames","Scale Frames to Loaded Layer", ]),		

		(PF_OPTION,   "type_create_back",   "Create Back From:", 2,["Text","Load Selected Layer\n  (with transparency)", "Don't Use"],{'tab':1}),
		(PF_DRAWABLE, "source_back", "  Selected Layer ➤ ", None,0,{'tab':1}),		
		(PF_FONT,     "font_name", "Font Name:", "Verdana",0,{'newLine':'0','tab':1} ),
		(PF_SPINNER,  "font_size_b", "   Font Size:",  500, (10, 1000, 1),{'newLine':'1','tab':1}),		
		(PF_TEXT,     "text_b", "Back Text :", "BACK",0,{'newLine':'0','tab':1} ),
		(PF_OPTION,   "align_back",   "   Align :", 0, ["Don't Use","Top", "Bottom"],{'tab':1}),			
		(PF_TOGGLE,   "type_fill_b",   "Fill Text:", 0,["Color","Pattern"],{'tab':1}),		
		(PF_COLOR,    "text_b_color", "   Color:", (128,128,128),0,{'newLine':'0','tab':1}),
		(PF_PATTERN,  "pattern_b", "   Pattern:", "Crack",0,{'newLine':'1','tab':1}),		
		(PF_OPTION,   "add_efect",   "Apply Effect:\n(decorative)", 0,["Don't Use","Camouflage","Canvas","Crystal","Cubism","Denim","Dirty","Edge","Edge Neon","Edge Sobel","Engrave","Gradient Map","Grid Cartesian","Grid Triangular","Ministeck","Mosaic","Pixelize","Plasma","Rainbow","Super-Pixels\nColors Average", "Super-Pixels\nColors Random","Video Degradation"],{'tab':1}),			
		(PF_TOGGLE,   "bump_text_b",   "Use BumpMap?", 1,["No","Yes"],{'tab':1}),
		(PF_TOGGLE,   "glow_b",   "Use NeonGlow?", 1,["No","Yes"],{'tab':1}),			
		(PF_COLOR,    "glowcolor_b", "   Glow Color:", (80,200,200),0,{'newLine':'0','tab':1}),
		(PF_SPINNER,  "glowsize_b", "   Glow Size:", 50, (0, 500, 1),{'newLine':'1','tab':1}),

		(PF_TOGGLE,   "type_create",   "Create Front From:", 0,["Text","Load Selected Layer\n  (with transparency)"],{'tab':2} ),	
		(PF_DRAWABLE, "source", "  Selected Layer ➤ ", None,0,{'tab':2} ),		
		(PF_FONT,     "font_name_f", "Font Name:", "Arial Bold",0,{'newLine':'0','tab':2}),
		(PF_SPINNER,  "font_size_f", "   Font Size:",  300, (10, 1000, 1),{'newLine':'1','tab':2}),		
		(PF_TEXT,     "text_f", "Front Text:", "FRONT",0,{'tab':2} ),
		#(PF_SPINNER,  "angle", "  custom angle: ", 0, (-360, 360, 1),{'newLine':1,'tab':2}),		
		(PF_TOGGLE,   "type_fill_f",   "Fill Text:", 0,["Color","Pattern"],{'tab':2}),		
		(PF_COLOR,    "text_f_color", "   Color:", (10,100,200),0,{'newLine':'0','tab':2}),
		(PF_PATTERN,  "pattern_f", "   Pattern:", "Crack",0,{'newLine':'1','tab':2} ),
		(PF_OPTION,   "add_efect_f",   "Apply Effect:\n(decorative)", 0,["Don't Use","Camouflage","Canvas","Crystal","Cubism","Denim","Dirty","Edge","Edge Neon","Edge Sobel","Engrave","Gradient Map","Grid Cartesian","Grid Triangular","Ministeck","Mosaic","Pixelize","Plasma","Rainbow","Super-Pixels\nColors Average", "Super-Pixels\nColors Random","Video Degradation"],{'tab':2}),			
		(PF_TOGGLE,   "bump_text_f",   "Use BumpMap?", 1,["No","Yes"],{'tab':2} ),		
		(PF_TOGGLE,   "glow_f",   "Use NeonGlow?", 1,["No","Yes"],{'tab':2} ),		
		(PF_COLOR,    "glowcolor_f", "   Glow Color:", (80,200,200),0,{'newLine':'0','tab':2}),
		(PF_SPINNER,  "glowsize_f", "   Glow Size:", 50, (0, 500, 1),{'newLine':'1','tab':2}),
		(PF_OPTION,   "type_anim",   "Type of Animation:", 0, ["Ripple","Sliding","Ripple & Sliding", "Crease","Shrink","Rotate", "Typewriter(\n(only Text)","Edges on Fire","Deform", "From Top to Bottom", "Explode", "Raindrops","Scanlines", "Wave", "Water", "Rotation about Y axis", "Rotation about X axis","Lava","From Top-Left to Bottom-Right","From Top-Right to Bottom-Left"],{'tab':2}),

		(PF_TOGGLE,   "overlay",   " ", 0,["Don't Use ","Use an Overlay (layer with transparency!)"],{'cols':6,'iniCol':0,'tab':3}),	
		(PF_DRAWABLE, "source_overlay", "Source Layer ➤", None,0,{'cols':6,'iniCol':0,'tab':3}),
		(PF_TOGGLE,   "autocrop_over",   "Autocrop?", 0,["No","Yes"],{'tab':3}),
		(PF_TOGGLE,   "centered_over",   "Align  MIDDLE? ", 0,["No","Yes"],{'tab':3}),
		(PF_TOGGLE,   "mir1", "Align TOP?", 0,["No","Yes"],{'newLine':'0','tab':3}),
		(PF_TOGGLE,   "mir2", "  Align BOTTOM?", 0,["No","Yes"],{'newLine':'1','tab':3}),
		(PF_TOGGLE,   "mir3", "Align RIGHT?", 0,["No","Yes"],{'newLine':'0','tab':3}),
		(PF_TOGGLE,   "mir4", "  Align LEFT?", 0,["No","Yes"],{'newLine':'1','tab':3}),
		(PF_SPINNER,  "mir_offset", "Distance to edge:", 0, (0, 100, 1),{'newLine':'1','tab':3}),	
		(PF_TOGGLE,   "scale_over",   "Scale to Frames?", 0,["No","Yes"],{'tab':3}),
		
		(PF_SPINNER,  "margin_x", "Margin X:", 0, (0, 500, 1),{'tab':4}),
		(PF_SPINNER,  "margin_y", "Margin Y:", 0, (0, 500, 1),{'tab':4}),
		(PF_SPINNER,  "frames", "Frames:", 10, (3, 100, 1),{'tab':4}),	
		(PF_TOGGLE,   "reverse",   "Reverse Frames?", 0,["No","Yes"],{'tab':4}),			
		(PF_TOGGLE,   "ping_pong",   "Ping-Pong?", 0,["No","Yes"],{'tab':4}),
		(PF_SPINNER,  "inScale", "Scale Animation (%):", 100, (10, 500, 1),{'tab':4}),		
		(PF_STRING,   "regex", "Rename Layers [*]:", "Your Name %03d (50ms)(replace)",0,{'tab':4}),	
		(PF_TOGGLE,   "play",   "Run Animation\nPlayback?", 0,["No","Yes"],{'tab':4}),
		
		(PF_TITLE,    "help"  , help ,(10,10), None ,{'tab':5}),			
		(PF_TAB    ,  "ptab"    , "tabs", 0, ("Background","Back", "Front", "Overlay", "General", "[*] ➤ Help") ),		
	],
	[],
	MrQ_animated_scene, menu="<Image>/Filters/Animation/Animators",
	domain=("gimp20", gimp.locale_directory))
main()							